﻿namespace UltraGridRefreshRowSelector
{
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;
    using Data_Models;

    public partial class SampleForm : Form
    {
        public SampleForm()
        {
            this.InitializeComponent();
            this.SampleGrid.DataSource = this.GetData();          
        }

        private void SampleGrid_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // Sets custom image to row selector when a row is in Active state
            e.Layout.RowSelectorImages.ActiveRowImage = Image.FromFile(@"../../Images/SelectedIcon.jfif");

            // Sets Custom image to Row selector when an Active row is being edited
            e.Layout.RowSelectorImages.ActiveAndDataChangedImage = Image.FromFile(@"../../Images/Pencil.png");

            // Sets Custom image to Row selector when Data in a row has been changed
            e.Layout.RowSelectorImages.DataChangedImage = Image.FromFile(@"../../Images/change.jfif");
        }

        private BindingList<Movie> GetData()
        {
            var movies = new BindingList<Movie>();
            movies.Add(
                new Movie
                {
                    Id = 1,
                    Title = "Terminator 2: Judgment Day",
                    Description = "A cyborg, identical to the one who failed to kill Sarah Connor, must now protect her young son, John Connor, from a more advanced cyborg, made out of liquid metal.",
                    Genre = "Action",
                    ReleaseYear = 2001,
                    Actors = new BindingList<Actor>
                {
                    new Actor { Id = 1, MovieId = 1, FirstName = "Arnold", LastName = "Schwarzenegger", Rating=30.4},
                    new Actor { Id = 2, MovieId = 1, FirstName = "Linda", LastName = "Hamilton", Rating = 45.12 },
                    new Actor { Id = 3, MovieId = 1, FirstName = "Edward", LastName = "Furlong", Rating = 56.32 },
                    new Actor { Id = 4, MovieId = 1, FirstName = "Robert", LastName = "Patrickg", Rating = 12.71 }
                }
                });
            movies.Add(
                new Movie
                {
                    Id = 2,
                    Title = "World War Z",
                    Description = "Former United Nations employee Gerry Lane traverses the world in a race against time to stop the Zombie pandemic that is toppling armies and governments, and threatening to destroy humanity itself.",
                    Genre = "Action",
                    ReleaseYear = 2014,
                    Actors = new BindingList<Actor>
                {
                    new Actor { Id = 5, MovieId = 2, FirstName = "Brad", LastName = "Pitt", Rating = 100},
                    new Actor { Id = 6, MovieId = 2, FirstName = "Mireille", LastName = "Enos", Rating = 12.45 },
                    new Actor { Id = 7, MovieId = 2, FirstName = "Daniella", LastName = "Kertesz", Rating = 78.3 },
                    new Actor { Id = 8, MovieId = 2, FirstName = "Drew", LastName = "Goddard", Rating= 43.96}
                }
                });
            movies.Add(
                new Movie
                {
                    Id = 3,
                    Title = "Prometheus",
                    Description = "Following clues to the origin of mankind a team journey across the universe and find a structure on a distant moon containing a monolithic statue of a humanoid head and stone cylinders of alien blood but they soon find they are not alone.",
                    Genre = "Adventure",
                    ReleaseYear = 2015,
                    Actors = new BindingList<Actor>
                {
                    new Actor { Id = 9, MovieId = 3, FirstName = "Noomi", LastName = "Rapace", Rating = 63.9},
                    new Actor { Id = 10, MovieId = 3, FirstName = "Logan", LastName = "Marshall-Green", Rating = 43.89},
                    new Actor { Id = 11, MovieId = 3, FirstName = "Michaela", LastName = "Fassbende", Rating = 91.2 },
                    new Actor { Id = 12, MovieId = 3, FirstName = "Charlize", LastName = "Theron", Rating = 73.12 }
                }
                });
            movies.Add(
                new Movie
                {
                    Id = 4,
                    Title = "Secondhand Lions",
                    Description = "A coming-of-age story about a shy, young boy sent by his irresponsible mother to spend the summer with his wealthy, eccentric uncles in Texas.",
                    Genre = "Comedy",
                    ReleaseYear = 2013,
                    Actors = new BindingList<Actor>
                {
                    new Actor { Id = 13, MovieId = 4, FirstName = "Haley Joel", LastName = "Osment", Rating=21},
                    new Actor { Id = 14, MovieId = 4, FirstName = "Michael", LastName = "Caine", Rating = 61.05 },
                    new Actor { Id = 15, MovieId = 4, FirstName = "Robert", LastName = "Duvall", Rating = 19.34 }
                }
                });
            movies.Add(
               new Movie
               {
                   Id = 5,
                   Title = "Salt",
                   Description = "A CIA agent goes on the run after a defector accuses her of being a Russian spy.",
                   Genre = "Crime",
                   ReleaseYear = 2016,
                   Actors = new BindingList<Actor>
               {
                    new Actor { Id = 16, MovieId = 5, FirstName = "Angelina", LastName = "Jolie", Rating = 99.9},
                    new Actor { Id = 17, MovieId = 5, FirstName = "Liev", LastName = "Schreiber", Rating = 38.4 },
                    new Actor { Id = 18, MovieId = 5, FirstName = "Chiwetel", LastName = "Ejiofor", Rating = 58.14 }
               }
               });
            return movies;
        }    
    }    
}
